 #include <stdint.h>
 
sbit FLASH_2_HLD at RC1_bit;
sbit FLASH_2_HLD_DIR at TRISC1_bit;
sbit FLASH_2_CS at RC2_bit;
sbit FLASH_2_CS_DIR at TRISC2_bit;
sbit FLASH_2_WP at RD0_bit;
sbit FLASH_2_WP_DIR at TRISD0_bit;

void main() 
{ 

   uint8_t buffer[4]                   = {15,20,25,30};
   uint32_t count                      = 4;
   uint32_t address                    = 0x010000;
   uint8_t receive_buffer[4];
   char tmp[20];
   
   FLASH_2_HLD_DIR = 0;
   FLASH_2_WP_DIR  = 0;
   FLASH_2_CS_DIR  = 0;

   Delay_ms(1000);
   SPI3_Init_Advanced( _SPI_MASTER,
                                        _SPI_8_BIT,
                                        80,
                                        _SPI_SS_DISABLE,
                                        _SPI_DATA_SAMPLE_MIDDLE,
                                        _SPI_CLK_IDLE_LOW,
                                        _SPI_IDLE_2_ACTIVE );
  Delay_ms(300);

  UART2_Init( 9600 );
  Delay_ms(300);
  UART2_Write_Text( "Initializing Flash 2 click... " );
  UART2_Write_Text( "\r\n" );
  flash_2_init();
  Delay_ms(300);
  flash_2_global_block_unlock();
  Delay_ms(400);
  flash_2_chip_erase();
  Delay_ms(300);
  flash_2_write( address, buffer, count );
  flash_2_read( address, receive_buffer, count );

  UART2_Write_Text( "Initial Values: " );
  while( count-- )
  {
     ByteToStr( buffer[count], tmp );
     UART2_Write_Text( tmp );
  }
  UART2_Write_Text( "\r\n" );
  count = 4;

  UART2_Write_Text( "Received Values: " );
  while( count -- )
  {
     ByteToStr( receive_buffer[count], tmp );
     UART2_Write_Text( tmp );
  }
  UART2_Write_Text( "\r\n" );

  return;

}